# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from boids_api.boids.base_model import Model
from boids_api.boids.boid import Boid
from boids_api.boids.pagination import Pagination
from boids_api import util


class BoidList(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, values: List[Boid]=None, pagination: Pagination=None):
        """BoidList - a model defined in OpenAPI

        :param values: The values of this BoidList.
        :param pagination: The pagination of this BoidList.
        """
        self.openapi_types = {
            'values': List[Boid],
            'pagination': Pagination
        }

        self.attribute_map = {
            'values': 'values',
            'pagination': 'pagination'
        }

        self._values = values
        self._pagination = pagination

    @classmethod
    def from_dict(cls, dikt: dict) -> 'BoidList':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The BoidList of this BoidList.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def values(self):
        """Gets the values of this BoidList.


        :return: The values of this BoidList.
        :rtype: List[Boid]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this BoidList.


        :param values: The values of this BoidList.
        :type values: List[Boid]
        """
        if values is None:
            raise ValueError("Invalid value for `values`, must not be `None`")

        self._values = values

    @property
    def pagination(self):
        """Gets the pagination of this BoidList.


        :return: The pagination of this BoidList.
        :rtype: Pagination
        """
        return self._pagination

    @pagination.setter
    def pagination(self, pagination):
        """Sets the pagination of this BoidList.


        :param pagination: The pagination of this BoidList.
        :type pagination: Pagination
        """

        self._pagination = pagination
