# coding: utf-8

from datetime import date, datetime

from typing import List, Dict, Type

from boids_api.boids.base_model import Model
from boids_api.boids.session_timestamp import SessionTimestamp
from boids_api.boids.system_event import SystemEvent
from boids_api.boids.system_event_level import SystemEventLevel
from boids_api import util


class SystemMessageEvent(Model):
    """NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).

    Do not edit the class manually.
    """

    def __init__(self, timestamp: SessionTimestamp=None, level: SystemEventLevel=None, event_type: str=None, source: str=None, message: str=None):
        """SystemMessageEvent - a model defined in OpenAPI

        :param timestamp: The timestamp of this SystemMessageEvent.
        :param level: The level of this SystemMessageEvent.
        :param event_type: The event_type of this SystemMessageEvent.
        :param source: The source of this SystemMessageEvent.
        :param message: The message of this SystemMessageEvent.
        """
        self.openapi_types = {
            'timestamp': SessionTimestamp,
            'level': SystemEventLevel,
            'event_type': str,
            'source': str,
            'message': str
        }

        self.attribute_map = {
            'timestamp': 'timestamp',
            'level': 'level',
            'event_type': 'event_type',
            'source': 'source',
            'message': 'message'
        }

        self._timestamp = timestamp
        self._level = level
        self._event_type = event_type
        self._source = source
        self._message = message

    @classmethod
    def from_dict(cls, dikt: dict) -> 'SystemMessageEvent':
        """Returns the dict as a model

        :param dikt: A dict.
        :return: The SystemMessageEvent of this SystemMessageEvent.
        """
        return util.deserialize_model(dikt, cls)

    @property
    def timestamp(self):
        """Gets the timestamp of this SystemMessageEvent.


        :return: The timestamp of this SystemMessageEvent.
        :rtype: SessionTimestamp
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this SystemMessageEvent.


        :param timestamp: The timestamp of this SystemMessageEvent.
        :type timestamp: SessionTimestamp
        """
        if timestamp is None:
            raise ValueError("Invalid value for `timestamp`, must not be `None`")

        self._timestamp = timestamp

    @property
    def level(self):
        """Gets the level of this SystemMessageEvent.


        :return: The level of this SystemMessageEvent.
        :rtype: SystemEventLevel
        """
        return self._level

    @level.setter
    def level(self, level):
        """Sets the level of this SystemMessageEvent.


        :param level: The level of this SystemMessageEvent.
        :type level: SystemEventLevel
        """
        if level is None:
            raise ValueError("Invalid value for `level`, must not be `None`")

        self._level = level

    @property
    def event_type(self):
        """Gets the event_type of this SystemMessageEvent.


        :return: The event_type of this SystemMessageEvent.
        :rtype: str
        """
        return self._event_type

    @event_type.setter
    def event_type(self, event_type):
        """Sets the event_type of this SystemMessageEvent.


        :param event_type: The event_type of this SystemMessageEvent.
        :type event_type: str
        """
        if event_type is None:
            raise ValueError("Invalid value for `event_type`, must not be `None`")

        self._event_type = event_type

    @property
    def source(self):
        """Gets the source of this SystemMessageEvent.


        :return: The source of this SystemMessageEvent.
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this SystemMessageEvent.


        :param source: The source of this SystemMessageEvent.
        :type source: str
        """
        if source is None:
            raise ValueError("Invalid value for `source`, must not be `None`")

        self._source = source

    @property
    def message(self):
        """Gets the message of this SystemMessageEvent.


        :return: The message of this SystemMessageEvent.
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this SystemMessageEvent.


        :param message: The message of this SystemMessageEvent.
        :type message: str
        """
        if message is None:
            raise ValueError("Invalid value for `message`, must not be `None`")

        self._message = message
